

//FIXME:Is this the best namespace/scoping method?
jQuery.tabletImageSliderID = 1;

//
jQuery.fn.tabletImageSlider = function(options, alteringWidths) {

  //Index of current slideshow
  var currentSlider = '';

  //Holds current assumed window width
  var currentWindowWidth;

  //Screen widths at which to change slider size
  var boundaries = [];

  //Check whether multiple sizes are defined
  if (typeof alteringWidths === 'undefined') {
    currentSlider = 'all';
    var alteringWidths = {'all': options};
    options = {screenWidths: [['', 'all']],
               stopWidth:options.stopWidth,
                stopSlides:options.stopSlides};
  }
  //Work out current width
  else {

    //FIXME: Assumed to be in correct order
    var screenWidthsLength = options.screenWidths.length;
    for (var i=0; i<screenWidthsLength; i++) {
      //Add boundary to list
      if (options.screenWidths[i][0] !== '') {
        boundaries.push(options.screenWidths[i][0]);
      }

    }

  }

  //Holds persistent settings
  var settings = {};

  //Calculate settings for each slideshow size, using defaults if required.
  var thisWidth;
  var screenWidthsLength = options.screenWidths.length;
  for (var i=0;i<screenWidthsLength; i++) {

    thisWidth = options.screenWidths[i][1];

    //Combine default settings
    settings[thisWidth] = $.extend( {
      pageElements: null,
      pageImages: [{file:'./images/need/defining', width:0, height:0}],
      screenWidth: 200,
      screenHeight: 200,
      pageOffset: {top:0, left:0},
      autoSlidePeriod: 3000,
      autoSlideDelay: 3000,
      transitionSpeed: 3000,
      pageZIndex: 1,

      snapSpeed:100,

      pageDotImage: './images/page_dot_5x5.png',
      pageDotFillerImage: './images/page_dot_filler_5x5.png',
      pageDotSize: {width:5, height:5},
      pageDotSpacing: 7,
      pageDotTopProp: 0.88,
      pageDotTop: null,
      pageDotCenter: null,

      currentPage: 0, //Less than 0 results in image starting

      releaseSpeedCutOff: 0.05,
      releaseSpeedUpdateInterval: 35,
      releaseDistance: 7,
      releaseGestureAcc: 0.97, //Used to calculate how far a gesture moves a frame

      releaseUpdateAccInv: 1.2, //Used for each animation update
      releaseSpeedLimit: 2,

      //Used for binding and unbinding on window
      uniqueID: 'tabletImageSlider_'+jQuery.tabletImageSliderID++


    }, alteringWidths[thisWidth]);

    //If not defined calculate pageDotSize/Center
    if (typeof settings[thisWidth].pageDotTop !== 'number') {
      settings[thisWidth].pageDotTop = settings[thisWidth].pageOffset.top + 
                            (settings[thisWidth].screenHeight*settings[thisWidth].pageDotTopProp);
    }
    if (typeof settings.pageDotCenter !== 'number') {
      settings[thisWidth].pageDotCenter = settings[thisWidth].pageOffset.left + 
                                settings[thisWidth].screenWidth/2;
    }
  }

    //Function called when window resized
    function resizeHandler(event) {
      
      //FIXME: Is this correct scoping?
      var newWindowWidth = $(window).width();

      //Check whether the width or height has changed at all
      if (newWindowWidth === currentWindowWidth) {
        return;
      }


      //Check for stopWidth
      if (typeof options.stopWidth !== 'undefined') {

        //Check if new cross stop width and which direction
        //
        //Negative
        if (newWindowWidth < event.data.options.stopWidth) {

          //Check whether just crossed or already crossed
          if ((currentWindowWidth > event.data.options.stopWidth) || 
              (!currentWindowWidth)) {

            //Stop
            currentWindowWidth && stopSlider(event.data.sliderObjs);

            //Re-render
            unwrapSlider(event.data.sliderObjs, event.data.options.stopSlides);
            
          }

          //
          currentWindowWidth = newWindowWidth;
          return;

        }
        //Positive
        else if ((currentWindowWidth < event.data.options.stopWidth) &&  
            (newWindowWidth > event.data.options.stopWidth)) {
          //
          wrapSlider(event.data.sliderObjs, event.data.options.stopSlides);

          //
          currentWindowWidth = 0;


        }

      }


//############################### 

      //Check whether a boundary has been crossed
      var boundariesCrossed = 0;
      var boundariesLength = boundaries.length;
      for (var i=0; i<boundariesLength; i++) {
        if ((boundaries[i] <= newWindowWidth) && 
            (boundaries[i] > currentWindowWidth)) {
          boundariesCrossed = 1;
          
        }
        else if ((boundaries[i] > newWindowWidth) && 
                 (boundaries[i] <= currentWindowWidth)) {
          boundariesCrossed = -1;
        }
      }
      
      //If boundary crossed (or new page) get new bounday 
      if ((boundariesCrossed !== 0) || (!currentWindowWidth)) {

        //Stop and reset current slider
        currentWindowWidth && stopSlider(event.data.sliderObjs);
    
        //Get new size
        //FIXME: Assumed to be in correct order
        var screenWidthsLength = options.screenWidths.length;
        for (var i=0; i<screenWidthsLength; i++) {
          //
          if ((newWindowWidth < options.screenWidths[i][0]) || 
              (options.screenWidths[i][0] === '')) {
            currentSlider = options.screenWidths[i][1];
            break;
          }
        }
      
        //Start new size
        event.data.sliderObjs.each(function() {
          startSlider.call(this);
        });

        //Set new currentWidth
        currentWindowWidth = newWindowWidth;

      }


    } 

    //Call resize function
    resizeHandler({data:{sliderObjs:this, 
                         options:options, 
                         boundaries:boundaries}});


  //If more than one width specified then add change width handler
  if ((options.screenWidths.length > 1) ||
      (typeof options.stopWidth !== 'undefined')) {


    //
    $(window).resize({sliderObjs:this, options:options, boundaries:boundaries}, resizeHandler);


  }
  
   
  //Function called to unwrap slides and display statically
  function unwrapSlider(sliderObjects, stopSlides) {

    //Do for each object 
    sliderObjects.each(function() {

      //Get the jquery object from the DOM element
      $this = $(this);

      //Hide current slides
      $this.find('li').hide();

      //Reveal and set CSS for stop slides
      stopSlides.show().css({left:'auto', 
                                  top:'auto', 
                                  width:'98%',
                                  margin:'4px 1%',
                                  position:'relative',
                                  'border-radius':7});
    
      $this.css('width', '100%');

    });

  }

  //Re-wrap slides
  function wrapSlider(sliderObjects, stopSlides) {

    //Do for each object 
    sliderObjects.each(function() {

      //Get the jquery object from the DOM element
      $this = $(this);

      $this.siblings('.slide-prompt').css('display', '');

      //
      $this.find('li').css('display', '');
    
      //
      stopSlides.attr('style', '');

      //Set width to auto
      $this.css('width', '');

    });


  }

  //Stops slider
  function stopSlider(sliderObjects) {

    //Do for each object 
    sliderObjects.each(function() {

    
      //Get the jquery object from the DOM element
      $this = $(this);

      //Unbind
      $this.unbind("touchstart");
      $this.unbind("touchstop");
      $this.unbind("touchmove");

      //Unbind corect handlers from window
      $(window).unbind('mouseup.'+$this.data('tabletImageSlider').uniqueID);
      $(window).unbind('mousedown.'+$this.data('tabletImageSlider').uniqueID);
      $this.unbind("mousemove");

      //Stop animations
      $this.find('*').stop(true, false);

      //Stop all registered timeouts
      $.each($this.data('tabletImageSlider').timeoutVars, function(name,value) { 
        clearTimeout(value);
      });
      
      //Reset co-ords or slides
      var tabletPageObjectsLength = $this.data('tabletImageSlider').tabletPageObjects.length;
      for (var i=0; i<tabletPageObjectsLength;i++) { 
        $this.data('tabletImageSlider').tabletPageObjects[i].css('left', '');  
      }

      //Delete page dots
      $this.find('.page-dot').remove();     

      //Reset Data
      $this.data('tabletImageSlider', 0);


    });

  }


  //
  function startSlider() {

    //Get the jquery object from the DOM element
    $this = $(this);

    //Check if already initiated
    var data = $this.data('tabletImageSlider');

    if (!data) {
      //
      //FIXME:
      settings[currentSlider].timeoutVars = {};


      //Holds page objects
      var tabletPageObjects = new Array();
      //Number of pages
      var numberOfPages;      

      //Check whether to use html element supplied or create for images
      //Create new
      if (settings[currentSlider].pageElements === null) {

        //Cache length of array
        numberOfPages = settings[currentSlider].pageImages.length;
        //Add div pages 
        for(var i=0; i<numberOfPages; i++) {
          //Add div and accompanying inline style
          tabletPageObjects.push(
              $("<div/>").css({
                  'background-image': 'url('+settings[currentSlider].pageImages[i].file+')',
                  'width': settings[currentSlider].pageImages[i].width,
                  'height': settings[currentSlider].pageImages[i].height,
                  'position': 'absolute',
                  'z-index': settings[currentSlider].pageZIndex,
                  'top': settings[currentSlider].pageOffset.top+'px',
                  'left': (-settings[currentSlider].screenWidth + settings[currentSlider].pageOffset.left)
               }).appendTo($this));   
        };
      }
      //Use existing
      else {
        //Get number of elements
        numberOfPages = settings[currentSlider].pageElements.length;
        //Split into seperate jquery objects
        for (var i=0; i<numberOfPages; i++) {
          tabletPageObjects.push($(settings[currentSlider].pageElements.get(i)));
        }
      }

      //Add dots
      var dots = Array();

      //Check whether odd or even number of pages
      var dotPoint = {top:settings[currentSlider].pageDotTop, left:settings[currentSlider].pageOffset.left};
      if (numberOfPages % 2) {
        dotPoint.left = settings[currentSlider].pageDotCenter - settings[currentSlider].pageDotSize.width/2 -
                        ((numberOfPages - 1)/2 * 
                         (settings[currentSlider].pageDotSize.width + settings[currentSlider].pageDotSpacing));
      }
      else {
        dotPoint.left = settings[currentSlider].pageDotCenter -
                         ((((numberOfPages/2) -1) * 
                            (settings[currentSlider].pageDotSize.width + settings[currentSlider].pageDotSpacing))
                        + (settings[currentSlider].pageDotSize.width + settings[currentSlider].pageDotSpacing/2));
      }

      //Add CSS for inner and outer of dots
      $("<style type='text/css'> \
        .page-dot { \
          position:absolute; \
          background-image:url("+settings[currentSlider].pageDotImage+");\
          width:5px;\
          height:5px;\
          z-index:10;\
        }\
        \
        .page-dot-filler {\
          position:absolute;\
          top:0px;\
          left:0px;\
          background-image:url("+settings[currentSlider].pageDotFillerImage+");\
          width:5px;\
          height:5px;\
        }\
      </style>").appendTo("head");

      //
      var outerDot;
      var dotFiller;
      for(var i=0; i<numberOfPages; i++) {
        //Create outer dot
        outerDot = $("<div/>").css({
            'top': dotPoint.top+'px',
            'left': dotPoint.left+'px'}).addClass('page-dot').appendTo($this);
        //Create filler 
        dotFiller = 
            $("<div/>").hide().addClass('page-dot-filler').appendTo(outerDot);  
        //Add divs to array       
        dots.push({outer: outerDot, filler: dotFiller});

        //Update position for next dot
        dotPoint.left += settings[currentSlider].pageDotSize.width + settings[currentSlider].pageDotSpacing;
      }
  
      //Add mouse and touch events
      
      //Touch

      //Touchstart of tablet outer - not interested in tuch events outside of 
      //tablet unlike for mouse. The main reason is it would mess with scrolling
      //. Firtunetly touchmoves are fired on the element from which the 
      //touchstart originated. 
      $this.bind("touchstart", function (event) {
        //Stop scrolling (and other behaviour)
        //event.preventDefault();
  
        //Store intial values for position and time
        $(this).data('tabletImageSlider').previousMouseTmp = 
                [{x:event.originalEvent.changedTouches[0].clientX, 
                  y:event.originalEvent.changedTouches[0].clientY}];
        $(this).data('tabletImageSlider').previousTimeTmp = 
                        [(new Date).getTime()];
      
      });

      //Touchend of tablet outer
      $this.bind("touchend", function (event) {

        //Check movement was vertical or horizontal
        if (!$(this).data('tabletImageSlider').horizontal) {
          return;
        }      

        //Stop scrolling (and other behaviour)
        event.preventDefault();

        //This function is called after checking for a slide
        var completeMove = (function (sliderObj) {
                 return  function () {
                        //If not still on auto slide snap pages to position
                          sliderObj.tabletImageSlider.snapToScreen.call(
                                        sliderObj);

                                      };
                            })($(this));


        //Call end of movement function 
        $(this).tabletImageSlider.completeSwipe.call(
                                        $(this),
                                        {
                x:event.originalEvent.changedTouches[0].clientX, 
                y:event.originalEvent.changedTouches[0].clientY},
                                        (new Date).getTime(),
                                          completeMove


                                        );
       

      });

      //
      $this.bind("touchmove", function (event) {

        //Get data object
        var data = $(this).data('tabletImageSlider');

        //If movement is known to be vertical quit
        if ((data.previousMouseTmp === null) && (!data.horizontal)) {
          return;
        }

        //Check if this is first touchmove after a touchstart
        if (data.previousMouseTmp !== null) {
          //Store touchstart variables in confirmed variables
          data.previousMouse = data.previousMouseTmp;
          data.previousTime = data.previousTimeTmp;

          //Work out how far we've moved
          var distanceMovedTmp = {
              x:event.originalEvent.changedTouches[0].clientX - 
                  data.previousMouse.slice(-1)[0].x,
              y:event.originalEvent.changedTouches[0].clientY - 
                  data.previousMouse.slice(-1)[0].y};

          //Check if this first movement is vertical or horizontal
          if (Math.abs(distanceMovedTmp.y) > Math.abs(distanceMovedTmp.x)) {
            data.horizontal = 0;
            //Null temp var to signal assignment 
            data.previousMouseTmp = null;
            return;
          }
          data.horizontal = 1;

          //Null temp var to signal assignment 
          data.previousMouseTmp = null;

        }

        //Work out how far we've moved (maybe again)
        var distanceMoved = {
            x:event.originalEvent.changedTouches[0].clientX - 
                data.previousMouse.slice(-1)[0].x,
            y:event.originalEvent.changedTouches[0].clientY - 
                data.previousMouse.slice(-1)[0].y};


        //Store current mouse position
        data.previousMouse.push({
            x:event.originalEvent.changedTouches[0].clientX, 
            y:event.originalEvent.changedTouches[0].clientY});

        //Stop scrolling (and other behaviour)
        event.preventDefault();

        //Stop curent animation 
        data.continueAnimation = 0;

        //Set flag to handle swipe
        data.unhandledSwipe = 1;

        //Stop slide show (if needed)          
        data.autoSlide = 0;

        //Stop any current animations
        for (var i=0; i<data.tabletPageObjectsLength;i++) { 
          data.tabletPageObjects[i].stop(true,false);                                          }

        //Call function to update position
        $(this).tabletImageSlider.updateTabletPosition.call(
                        $(this),
                        distanceMoved);

        //Store current time
        data.previousTime.push((new Date).getTime());

      });

      //Mouse

      //When mouse down set flag 
      $(this).bind('mousedown.'+settings[currentSlider].uniqueID, {sliderObj:$this}, function (event) {
              //Check for correct button
              if (!(event.which === 1)) {
                return;
              }

              //Set this
              var $this = event.data.sliderObj;

              //Set mouse down flag
              $this.data('tabletImageSlider').mousedown = 1;
              //Set position and time
              $this.data('tabletImageSlider').previousMouseTmp = 
                          [{x:event.pageX, y:event.pageY}];
              $this.data('tabletImageSlider').previousTimeTmp = 
                        [(new Date).getTime()];



              //Handle end of event. Trigger on both mouseup and dragend (as 
              //mouse up won't get fired)
              function mouseupHandler(event) {

                  //Check for correct button
                  if (!(event.which === 1)) {
                    return;
                  }

                  event.preventDefault();

                  //Set this
                  var $this = event.data.sliderObj;

                  //This function is called after checking for a slide
                  var completeMove = (function (sliderObj) {
                      return  function () {
                        //If not still on auto slide snap pages to position
                          sliderObj.tabletImageSlider.snapToScreen.call(
                                        sliderObj);

                                          };
                       })($this);


                  //Call end of movement function 
                  $this.tabletImageSlider.completeSwipe.call(
                                    $this,
                                    {x:event.pageX, y:event.pageY},
                                    (new Date).getTime(),
                                    completeMove
                                    );

                  //Set mouse down flag
                  $this.data('tabletImageSlider').mousedown = 0;
                  //Unbind this handler from mouseend and dragend
                  $(this).unbind('dragend', mouseupHandler);
                  $(this).unbind('mouseup', mouseupHandler);
                };


              $(document).bind('dragend',{sliderObj:$this}, mouseupHandler);
              $(document).bind(
                      'mouseup.'+$this.data('tabletImageSlider').uniqueID, 
                       {sliderObj:$this},mouseupHandler);
      });

      //When mouse moves, check whether button is pressed
      $this.mousemove(function (event) {
              var data = $(this).data('tabletImageSlider');            
  
              //Is moused pressed within
              if (data.mousedown) {

                event.preventDefault();

                //Stop curent animation 
                data.continueAnimation = 0;
  
                //Store touchstart variables in confirmed variables
                if (data.previousMouseTmp !== null) {
                  data.previousMouse = data.previousMouseTmp;
                  data.previousTime = data.previousTimeTmp;

                  //Null temp var to signal assignment 
                  data.previousMouseTmp = null;

                }

                //Set flag to handle swipe
                data.unhandledSwipe = 1;
                //Stop slide show (if needed)          
                data.autoSlide = 0;
                //Stop any current animations
                for (var i=0; i<data.tabletPageObjectsLength;i++) { 
                  data.tabletPageObjects[i].stop(true,false);            
                }
                //Work out how far we've moved horizontally
                var distanceMoved = {x:event.pageX - 
                                        data.previousMouse.slice(-1)[0].x,
                                     y:event.pageY - 
                                        data.previousMouse.slice(-1)[0].y};

                //Call function to update position
                $(this).tabletImageSlider.updateTabletPosition.call(
                                $(this),
                                distanceMoved);

                //Store current mouse position
                data.previousMouse.push({x:event.pageX, y:event.pageY});

                //Store current time
                data.previousTime.push((new Date).getTime());
                                       
              }

       });
  
      //Stop dragging (ie drag 'n' drop) on all imgs
      var tabletPageObjectsLength = tabletPageObjects.length;
      for (var i=0; i<tabletPageObjectsLength;i++) { 
        tabletPageObjects[i].find('img').bind('dragstart', 
                        function(event) {event.preventDefault();});
      }


      //Check whether to show image now
      if (settings[currentSlider].currentPage > -1) {
        //Move image to center
        tabletPageObjects[settings[currentSlider].currentPage].css('left', 
                                                      settings[currentSlider].pageOffset.left);
        //Set dot
        dots[settings[currentSlider].currentPage].filler.show();
      }

      //Store all variables in data object
      var data = $.extend( {
          tabletPageObjects: tabletPageObjects,
          tabletPageObjectsLength: tabletPageObjectsLength,
          dots: dots
      }, settings[currentSlider]);

      //Store variables in data container
      $this.data('tabletImageSlider', data);

      //Start tablet sliding update function

      //Create function for timeout that ensures correct scope for this
      var timeoutFunction = function (thisVar) {
        return function() {
          thisVar.tabletImageSlider.slideTablet.call(thisVar)
        };
      }($this);

      data.autoSlide = 1;
      data.timeoutVars.init =  setTimeout(timeoutFunction, 
                 settings[currentSlider].autoSlideDelay);

      }
    
  }

};


jQuery.fn.tabletImageSlider.completeSwipe = function(lastPosition, 
                                                     lastTime, 
                                                     onComplete) {

  //Get object variables
  var data = this.data('tabletImageSlider');

  //Check whether there has been an unhandled swipe
  if (data.unhandledSwipe) {
    //Unset flag
    data.unhandledSwipe = 0;
    
    //Caluclate distance and time between last point and previous
    var distanceX = lastPosition.x - data.previousMouse.pop().x;
    var time = lastTime - data.previousTime.pop();
    //Need last point that was different and time non-zero (if not get one)
    while ((!distanceX) || (!time)) {
      distanceX = lastPosition.x - data.previousMouse.pop().x;
      time = lastTime - data.previousTime.pop();
    }
    //Calculate speed
    var speed = distanceX/time;

    //If fast enough call animate function 
    if (Math.abs(speed) > 0.1)  {
      //Limit speed to avoid over scrolling
      if (Math.abs(speed) > data.releaseSpeedLimit) {
        //Set correct sign
        if (speed > 0) {
          speed = data.releaseSpeedLimit;
        }
        else {
          speed = -data.releaseSpeedLimit;
        }
      }

      //Calculate new position
      //FIXME: use less expensive estimate
      var initialDistance = 0;
      while (Math.abs(speed) > data.releaseSpeedCutOff) {
        //
        initialDistance += speed*data.releaseDistance;
        //
        speed *= data.releaseGestureAcc;
      }

      //Round initial distance
      initialDistance = Math.round(initialDistance);

      //Adjust this to a boundary

      //Calculate proposed absoulte position
      var newDistance = initialDistance;
      var currentPageNewPos = 
        parseInt(data.tabletPageObjects[data.currentPage].css('left')) +   
        initialDistance;

      //Get the difference from proposed position to lower boundary
      var distanceToBoundary = (currentPageNewPos - data.pageOffset.left) 
                                % data.screenWidth;

      //Round number down to lower boundary
      newDistance -= distanceToBoundary;
      //Check if needs rounding up instead
      if (distanceToBoundary > data.screenWidth/2) {
        newDistance += data.screenWidth;
      }
      //Calculate required speeds to reach new distance FROM target (reverse)

      //Set initial speed at the lower 
      var stepSpeed = data.releaseSpeedCutOff;
      if (initialDistance < 0) {
        stepSpeed *= -1;
      }

      //Calculate speed at each update in reverse
      var distanceUpdates = new Array();
      var stepDistance;
      while (!(((initialDistance > 0) && (newDistance < 0)) ||
             ((initialDistance < 0) && (newDistance > 0)))) {
        //Distance to travel in update    
        stepDistance = Math.round(stepSpeed*data.releaseDistance);
        //Add this distance to array (if not zero)
        stepDistance && distanceUpdates.push(stepDistance);
        //Update distance 
        newDistance -= stepDistance;
        //Update speed
        stepSpeed *= data.releaseUpdateAccInv;
      }

      //Round the first step distance (ie the last one just calculated) to make 
      //the distance correct
      distanceUpdates[distanceUpdates.length-1] += newDistance;

      //Start animation of button release
      data.continueAnimation = 1;
      this.tabletImageSlider.animateButtonRelease.call(this,
                                            distanceUpdates, 
                                            onComplete);
    }
    else {
      onComplete();
    }

  }


};

var timingConst;

jQuery.fn.tabletImageSlider.animateButtonRelease = function(
                            distanceUpdates, 
                            onComplete) {

  if ((!this.data('tabletImageSlider')) ||
    (!this.data('tabletImageSlider').continueAnimation)) {
    return;
  }

  //Flag for last loop to call complete function
  var completed = 0;

  //Get new distance to travel
  var thisStepDistance = distanceUpdates.pop();

  //Call again if this isnt last (calling as early as possible)
  var _this = this;
  if (distanceUpdates.length > 0) {
    this.data('tabletImageSlider').timeoutVars.tabletImageSlider = setTimeout(function () {
      _this.tabletImageSlider.animateButtonRelease.call(
                  _this, distanceUpdates, onComplete);
      },this.data('tabletImageSlider').releaseSpeedUpdateInterval);
  }
  else {
    //Set complete
    completed = 1;
  }

  //Move pages required amount
  this.tabletImageSlider.updateTabletPosition.call(
                          this,
                          {x:thisStepDistance});

  //If last loop, run completion function (if set)
  completed && onComplete && onComplete();
};

jQuery.fn.tabletImageSlider.snapToScreen = function() {

  //Get object variables
  var data = this.data('tabletImageSlider');

  //Set new page index
  var newPage = data.currentPage + 1;
      
  //Check for overflow and start again
  if (newPage > (data.tabletPageObjects.length-1)) {
    newPage = 0;
  }

  //Check wether too far over to right and needs to snap to newpag
  if (parseInt(data.tabletPageObjects[data.currentPage].css('left')) > 
        (data.screenWidth/2 + data.pageOffset.left)) {

    data.tabletPageObjects[newPage].animate({
      left: data.pageOffset.left
    }, {
      duration: data.snapSpeed,
      //Move old page off
      step: function( now, fx ){
        data.tabletPageObjects[data.currentPage].css(
                "left", 
                (now + data.screenWidth));
      },
      complete: function() {
        //Set old page ready for its next animation (hide -> move -> show)
        data.tabletPageObjects[data.currentPage].css("visibility", 'hidden');
        data.tabletPageObjects[data.currentPage].css("left", 
                              (data.pageOffset.left-data.screenWidth));
        data.tabletPageObjects[data.currentPage].css("visibility", 'visible');
        //Set dots
        data.dots[data.currentPage].filler.hide();
        data.dots[newPage].filler.show();
        
        //Update current page count
        data.currentPage = newPage;
      }
    });


  }
  //Snap back to current page
  else if (parseInt(data.tabletPageObjects[data.currentPage].css('left')) > 
                                data.pageOffset.left) {
    
    data.tabletPageObjects[newPage].animate({
      left: data.pageOffset.left-data.screenWidth
    }, {
      duration: data.snapSpeed,
      //Move old page off
      step: function( now, fx ){
        data.tabletPageObjects[data.currentPage].css(
                "left", 
                (now + data.screenWidth));
      }
    });


  }
  //else = is exactly positioned

  return;
};


jQuery.fn.tabletImageSlider.updateTabletPosition = function(distanceMoved) {
 
//FIXME: Use css transitions were available
 
  //Get local copy
  var distanceMovedLeft = {x:distanceMoved.x,
                           y:distanceMoved.y};
  //Get object variables
  var data = this.data('tabletImageSlider');
  
  //Calculate new left value of current page
  var newLeft = parseInt(data.tabletPageObjects[data.currentPage].css('left')) + 
                distanceMovedLeft.x;

  //Check if movement requires new object from left
  if (newLeft > (data.pageOffset.left + data.screenWidth - 1)) {

    //Set new page index
    var nextPage = data.currentPage + 1;
      
    //Check for overflow and start again
    if (nextPage > (data.tabletPageObjects.length-1)) {
      nextPage = 0;
    }

    //Reduce distance amount covered
    distanceMovedLeft.x = newLeft- data.pageOffset.left - data.screenWidth;

    //Update incoming page to center
    data.tabletPageObjects[nextPage].css('left', data.pageOffset.left);
    
    //Move current page accross
    data.tabletPageObjects[data.currentPage].css("visibility", 'hidden');
    data.tabletPageObjects[data.currentPage].css("left", (data.pageOffset.left - 
                                                          data.screenWidth));
    data.tabletPageObjects[data.currentPage].css("visibility", 'visible');

    //Set dots
    data.dots[data.currentPage].filler.hide();
    data.dots[nextPage].filler.show();
        
    //Update current page count
    data.currentPage = nextPage;

  }
  //New from right
  else if (newLeft < data.pageOffset.left) {
    //Set new page index
    var previousPage = data.currentPage + 1;
      
    //Check for overflow and start again
    if (previousPage > (data.tabletPageObjects.length-1)) {
      previousPage = 0;
    }

    //Reduce distance amount covered
    distanceMovedLeft.x = 
        distanceMovedLeft.x + 
            (parseInt(data.tabletPageObjects[data.currentPage].css('left')) - 
            data.pageOffset.left) + 
        1;

    //Move previous page off screen
    data.tabletPageObjects[previousPage].css("left", (data.pageOffset.left
                                                      -data.screenWidth));

    //Move current page to first spot on previous page slot
    data.tabletPageObjects[data.currentPage].css("left", data.pageOffset.left-1);

    //Set new page index
    var newPage = data.currentPage - 1;
      
    //Check for overflow and start again
    if (newPage < 0) {
      newPage = data.tabletPageObjects.length-1;
    }
  
    //Move new page over to right 
    data.tabletPageObjects[newPage].css("visibility", 'hidden');
    data.tabletPageObjects[newPage].css("left", (data.pageOffset.left + data.screenWidth - 1));
    data.tabletPageObjects[newPage].css("visibility", 'visible');

    //Set dots
    data.dots[data.currentPage].filler.hide();
    data.dots[newPage].filler.show();

    //Update current page
    data.currentPage = newPage;
    

  }
  //No boundaries will be crossed by the distance remaining
  else {
    //Set new page index
    var nextPage = data.currentPage + 1;
      
    //Check for overflow and start again
    if (nextPage > (data.tabletPageObjects.length-1)) {
      nextPage = 0;
    }
    //Update positions
    data.tabletPageObjects[data.currentPage].css('left', "+="+distanceMovedLeft.x);
    data.tabletPageObjects[nextPage].css('left',"+="+distanceMovedLeft.x);
    //
    return;
  }

  //If still distance remianing call function again
  if (distanceMovedLeft.x !== 0) {
    return this.tabletImageSlider.updateTabletPosition.call(this,distanceMovedLeft); 
  }
  
  return;
}


jQuery.fn.tabletImageSlider.slideTablet = function () {

  //Get object variables
  var data = this.data('tabletImageSlider');

  //Check whether to stop loop 
  if (!data.autoSlide) return;

  //Use alternative name of this
  var _this = this;

  //Set new page index
  var newPage = data.currentPage + 1;
      
  //Check for overflow and start again
  if (newPage > (data.tabletPageObjects.length-1)) {
    newPage = 0;
  }

  //Create function for timeout that ensures correct scope for this
  var timeoutFunction = function (thisVar) {
    return function() {
      thisVar.tabletImageSlider.slideTablet.call(thisVar)
    };
  }(this);


  //Check whether there is page loaded (-1 means no page on screen) 
  if (data.currentPage === -1) {
    //Create completion function 
    var completeFunction = function (thisVar, dataVar) {
      return function () {
        dataVar.currentPage = newPage;
        //Re-set timer to trigger page turn
        dataVar.timeoutVars.slideTablet = setTimeout(timeoutFunction, 
                   dataVar.autoSlidePeriod);
        //Set dot
        dataVar.dots[0].filler.show();
      }

    }(this, data);

    //Animate new object in
    data.tabletPageObjects[newPage].animate({
      left: "+="+data.screenWidth
    }, {
      duration: data.transitionSpeed,
      //When complete update variables and set call back timer
      complete:completeFunction
    });
  }
  //A page is already on screen
  else {
    //Create completion function 
    var completeFunction = function (thisVar, dataVar, newPageVar) {
      return function () {
        //Set old page ready for its next animation (hide -> move -> show)
        dataVar.tabletPageObjects[dataVar.currentPage].css("visibility", 'hidden');
        dataVar.tabletPageObjects[dataVar.currentPage].css("left", (dataVar.pageOffset.left-dataVar.screenWidth));
        dataVar.tabletPageObjects[dataVar.currentPage].css("visibility", 'visible');
        //Set dots
        dataVar.dots[dataVar.currentPage].filler.hide();
        dataVar.dots[newPageVar].filler.show();
        
        //Update current page count
        dataVar.currentPage = newPageVar;

        //Re-set timer to trigger page turn           
        dataVar.timeoutVars.slideTablet = setTimeout(timeoutFunction, 
                   dataVar.autoSlidePeriod);
      }
    }(this, data, newPage);


    //Animate new page in AND manually animate existing page out at each 
    //animate step
    data.tabletPageObjects[newPage].animate({
      left: "+="+data.screenWidth
    }, {
      duration: data.transitionSpeed,
      //Move old page off
      step: function( now, fx ){
        data.tabletPageObjects[data.currentPage].css(
                "left", 
                (now + data.screenWidth));
      },
      complete: completeFunction    
       });
  }
};

